// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
[m,path]=libraryinfo("toolbox_clarinetlib") ;
DEMOPATH = fullpath(path+"/../demos/") ;
fdrfile = DEMOPATH + "fdr_eagleriver.flt" ;
fdrcoding = [ 32,64,128 ; 16,255,1 ; 8,4,2 ] ;
fdr = CreateFlowDirFromBinary ( fdrfile, "f", fdrcoding ) ;
header = GetFlowDirGridHeader ( fdr ) ;
outlet = XY2rec ( header, [-929387,1901293] ) ;
t = CreateCellTree ( fdr, outlet ) ;
cellsize = header(3) ;
pixelarea = cellsize^2 ;
supportarea = 1e6 ;    // in square meters
supportweight = supportarea / pixelarea ;
[ STREAMS, StreamOrder ] = MakeStrahlerStreams ( t, supportweight ) ;


// PLOT
COLOR = jetcolormap(max(StreamOrder));
// Begin with 5 dummy plots in order to display legend correctly (Scilab trick) 
for i=1:max(StreamOrder)
    XY = rec2XY ( header, STREAMS(1)(1) );
    plot(XY(1),XY(2),"Color",COLOR(i,:),"LineWidth",i);
end
// Plot individual streams with different color & width depending on order
for i=1:length(STREAMS)
    XY = rec2XY(header,STREAMS(i));
    order = StreamOrder(i);
    plot(XY(:,1),XY(:,2),"Color",COLOR(order,:),"LineWidth",order)
end

a = gca();
a.isoview = "on";
xtitle("","X, easting (m)","Y, northing (m)");
legend(["order 1","order 2","order 3","order 4","order 5"]);
