// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function Z = Anamorph_LN ( U , mlog , slog , f0 )
    
    // Anamorphose log-normale avec valeur atomique en 0
        
    argerfinv = ( erf(U/sqrt(2)) - f0 ) ./ (1-f0);
    argerfinv(argerfinv<-1) = -1;

    ixinf = (1-argerfinv)<1e-15;

    logZ = zeros(U);
    logZ(~ixinf) = sqrt(2) * slog(~ixinf).* erfinv(argerfinv(~ixinf)) + mlog(~ixinf) ;
        
    ln1_x2 = log(2) - 0.5*U(ixinf).^2 - log(U(ixinf)) - log(1-f0(ixinf)) - 0.5*log(%pi) +0.5*log(2);
    approx = sqrt( sqrt ( ( 2/(%pi*0.147) + 0.5*ln1_x2 ).^2 - ln1_x2/0.147  ) - 2/(%pi*0.147) - 0.5*ln1_x2 );   
    logZ(ixinf) = sqrt(2) * slog(ixinf).* approx + mlog(ixinf) ;
    
    Z = exp(logZ);
    
endfunction
