// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function h = CreateConstantRaster(HandleSrc,const,varargin)
    
    if length(varargin,'*')>0 then
        nom = varargin(1);
    else
        nom = "noname";
    end
    
    Header = GetFloatRasterHeader (HandleSrc);
    select Header(7)
	case 1 then strLL = 'center',
	case 0 then strLL = 'corner',	
    end
 
    h = CreateFloatRaster(Header(1),Header(2),Header(3),Header(4),Header(5),Header(6),strLL,nom);    
    
    if( isnan(const) ) then
        SetRasterToNODATA(h);
    else
        SetRasterToConstant(h,const);
    end
    
endfunction
