// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function h = CreateFlowDirFromBinary (binfile,STR_TYPE,Compass,varargin)
    
    if length(varargin,'*')>0 then
        nom = varargin(1);
    else
        nom = "noname";
    end
    
    T = tokens(binfile,'.');
    ext = length(T($))+1;
    hdrfile = part(binfile,1:(length(binfile)-ext))+".hdr";
    
    select STR_TYPE,
      case 'c' then TYPE = 0,
      case 'uc' then TYPE = 1,
      case 's' then TYPE = 2,
      case 'us' then TYPE = 3,
      case 'i' then TYPE = 4,
      case 'ui' then TYPE = 5,
      case 'f' then TYPE = 6,
      case 'l' then TYPE = 7,
      case 'ul' then TYPE = 8,
      case 'd' then TYPE = 9
      else
          errormsg = sprintf("Argument 3 : type ''%s'' non reconnu\n",STR_TYPE);
          error(errormsg);
    end
    
    h = sci_FlowDirFromBinary(nom,binfile,hdrfile,TYPE,Compass);
    
        
endfunction
