// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [ MSE , BIAS , D_KS ] = CritJackknifeT ( TEMPER , XYZ_temper , LAPSERATE )

    ntemper = size(TEMPER,'c');
    MSE = zeros(length(LAPSERATE),ntemper);
    BIAS = zeros(length(LAPSERATE),ntemper);
    D_KS = zeros(length(LAPSERATE),ntemper);
    
    for t=1:ntemper
        
        mprintf("\n Poste %2d ",t)
        
        // Jackknife station t
        
        ixremain = [1:(t-1),(t+1):ntemper];
        
        [ VARIO_ResidualT , ResidualT_sample ] = DailyT_variography ( TEMPER(:,ixremain) , ..
                                                                      XYZ_temper(ixremain,:) ) ;        // çuici a un palier ???
        progress=0;

        for r = 1:length(LAPSERATE)

            [ VARIO_ResiTemplateT ] = TemplateT_variography ( TEMPER(:,ixremain) , ..
                                                              XYZ_temper(ixremain,:) , ..
                                                              LAPSERATE(r) ) ;       
                
            LocalT = BuildLocalTemperature2 ( TEMPER(:,ixremain) , XYZ_temper(ixremain,:) , ..
                                              LAPSERATE(r) , ..
                                              VARIO_ResiTemplateT , ..
                                              VARIO_ResidualT , ResidualT_sample , ..
                                              XYZ_temper(t,:) ) ;
        
            MSE(r,t) = mean ( [ TEMPER(:,t) - LocalT ].^2 ) ;
            D_KS(r,t) = KS_distance ( TEMPER(:,t), LocalT );            
            BIAS(r,t) = mean ( TEMPER(:,t) - LocalT );
            
            progress1 = floor(20*r/length(LAPSERATE));
            if progress1~=progress then
                progress=progress1;
                mprintf("*")
            end
           
//            mprintf("Poste %d, H = %d , MSE = %.1f , D_KS = %f\n",p,SCALEHEIGHT(h),MSE(h,p),D_KS(h,p))       
        
        end 
    
    end
    
    // Variography for the complete sample

endfunction
