// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function XY2 = DensifyPolyline ( XY , dmax )
    
    dxy = diff(XY,1,1);
    d = sqrt(sum(dxy.^2,'c'));
    s = [0;cumsum(d)];

    n = ceil(d/dmax)-1;   
    ix = find(n>0) ;
        
    if isempty(ix)
        XY2 = XY ;
        return ;
    end    
    
    X = XY(:,1);
    Y = XY(:,2);    
    
    sadd = [];
    XYadd = [];
     
    for i=1:length(ix) 
        
        saddi = [1:n(ix(i))]'/(n(ix(i))+1) * (s(ix(i)+1)-s(ix(i))) + s(ix(i)) ;
        Xaddi = [1:n(ix(i))]'/(n(ix(i))+1) * (X(ix(i)+1)-X(ix(i))) + X(ix(i)) ;
        Yaddi = [1:n(ix(i))]'/(n(ix(i))+1) * (Y(ix(i)+1)-Y(ix(i))) + Y(ix(i)) ;
        
        sadd = [sadd;saddi];
        XYadd = [XYadd;Xaddi,Yaddi];
        
    end

    s = [s;sadd];
    XY2 = [XY;XYadd];
    [s,ix] = gsort(s,'g','i');
    XY2 = XY2(ix,:);
    
endfunction
