// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function EcartRel = EvalMaillage ( PK , FLOWLINES , fdr , loc , id_cnstr )
    
    // Vecteur de paramètres : PK
    
    ncnstr = length(id_cnstr);
    nfl = length(FLOWLINES);
    
    NODES = zeros(ncnstr+nfl,1);
    NODES(1:ncnstr) = id_cnstr(:);
    Smaille = zeros(NODES);
    
    for i=1:nfl
        
        [m,ix] = min(abs(FLOWLINES(i)(:,1)-PK(i)));
        NODES(ncnstr+i) = FLOWLINES(i)(ix,2);        // Conversion PK -> id
        
    end
    
    for i=1:length(NODES)
        
        if ~isempty ( find ( NODES(1:(i-1)) == NODES(i) ) ) then
            Smaille(i)=0;
        else
            [Sum,bbox,ixUpNodes] = GetCatchmentSum( fdr , loc , NODES(i) , NODES(NODES~=NODES(i)) );
            Smaille(i) = Sum;    
        end
        
    end
    
    EcartRel = Smaille/mean(Smaille) - 1 ;
    
endfunction
