// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function FillAccumulationMap (fdr,outlet,acc,varargin)
    	
	//------------------------------------------------------------------------------
	// Read optional arguments

    nargs = length(varargin,'*');
    INLETS = [];
    useweight = %F ;
	method = "sum" ;
        
    if nargs>0 then
        
        if modulo(nargs,2)~=0
            error("Invalid list of optional arguments");
        end

        // Lecture des clés et des arguments associés
        
        for i=2*[1:(nargs/2)]
            
            if convstr(varargin(i-1),"l")=="inlets" then
                INLETS = varargin(i);
            end

            if convstr(varargin(i-1),"l")=="weight" then
                useweight = %T;
                wras = varargin(i);
            end

            if convstr(varargin(i-1),"l")=="method" then
                select varargin(i),
					case "sum" then method = "sum", 
					case "mean" then method = "mean", 
					else error("Keyword ''method'' must be used in conjunction with either ''sum'' or ''mean''")
				end				
            end	
            
        end
        
    end
	
	//-------------------------------------------------------------------------------------
	
	if useweight & method=="sum" then
		sci_MapCatchmentSum(fdr,outlet,INLETS,acc,wras);
	end
	
	if useweight & method=="mean" then
		sci_MapCatchmentMean(fdr,outlet,INLETS,acc,wras);
	end
	
	if ~useweight & method=="sum" then
		sci_MapCatchmentSum1(fdr,outlet,INLETS,acc);
	end
	
	if ~useweight & method=="mean" then
		error("Please specify a weight raster in conjunction with option ''mean''");
	end
	
endfunction
