// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [Sum,BoundingBox,ix_up] = GetCatchmentSum (fdr,exu,varargin)
    
    Nodes = [];
    useweight = %F;
    
    nargs = length(varargin,'*');
    
    if nargs>0 then
        
        if modulo(nargs,2)~=0
            error("Syntaxe incorrecte");
        end

        // Lecture des clés et des arguments associés
        
        for i=2*[1:(nargs/2)]
            
            if convstr(varargin(i-1),"l")=="inflows" then
                Nodes = varargin(i);
            end

            if convstr(varargin(i-1),"l")=="weight" then
                useweight = %T;
                weightraster = varargin(i);
            end
            
        end
        
    end
    
    if useweight then
                
        [Sum,BoundingBox,ix_up] = sci_GetCatchmentSum (fdr,exu,Nodes,weightraster);    // Sommation de la carte de poids
        
    else
        
        [Sum,BoundingBox,ix_up] = sci_GetCatchmentSum1 (fdr,exu,Nodes);    // Sommation de l'indicatrice (w=1 partout)
        
    end   
    
    ix_up = ix_up + 1 ;  // Les indices commencent à 0 en C
        
endfunction
