// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [ Polyline2 ] = GridIntersect ( Polyline , GridOrigin , a )
    
    X0 = GridOrigin(1);
    Y0 = GridOrigin(2);
 
    PolyRed = [ Polyline-[X0,Y0].*.ones(Polyline(:,1)) ] / a ; 
    PolyVec = diff(PolyRed,1,1);
    
    PolyRed2 = PolyRed(1,:);
        
    for i=1:size(PolyVec,'r')
    
        u = PolyVec(i,:)' ;
        
        // Identification des intersections entre le segment et la grille
        
        xdeb = PolyRed(i,1);
        xfin = PolyRed(i+1,1);
        ydeb = PolyRed(i,2);
        yfin = PolyRed(i+1,2);
        
        grid_x = ceil(min(xdeb,xfin)):floor(max(xdeb,xfin)) ;
        
        if ( u(1)~=0 & ~isempty(grid_x)) then
            t_x = (grid_x - xdeb) / u(1) ;
        else
            t_x = [];
        end
    
        grid_y = ceil(min(ydeb,yfin)):floor(max(ydeb,yfin)) ;
       
        if ( u(2)~=0 & ~isempty(grid_y)) then
            t_y = (grid_y - ydeb) / u(2) ;
        else
            t_y = [];
        end
        
        t = gsort([t_x,t_y],'g','i');
        t = [t,1] ;
    
        P = u .*. t + [xdeb ; ydeb ] .*. ones(t) ; 
        
        PolyRed2 = [ PolyRed2 ; P' ];
        
    end

    Polyline2 =  a * PolyRed2 + [X0,Y0].*.ones(PolyRed2(:,1)) ; 

endfunction
