// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [Ix,W] = InterpQuantile (f,n)
    
    // Renvoie les indices et les poids des statistiques d'ordre d'un échantillon de taille n à utiliser pour estimer des quantiles
    // f : vecteur
    // n : entier
    // Une estimation du quantile f(i) est donnée par X(Ix(i,1))*W(i,1) + X(Ix(i,2))*W(i,2)
    
    i = (n+1-2*0.31) * f(:) + 0.31 ;

    if or(i<1) | or(i>n) then
        error("un ou plusieurs quantiles demandés sont en extrapolation !");
    end

    Ix = [floor(i),ceil(i)];
    
    W = i-Ix(:,1);
    W = [1-W,W];
            
endfunction
