// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function ii = IntersectionIndic ( TabHandleThreshold , NODATA_value )
    
    Headers = zeros(7,size(TabHandleThreshold,'r'));
    
    for h=1:size(TabHandleThreshold,'r')
        Headers(:,h) = GetFloatRasterHeader(TabHandleThreshold(h,1));
    end
       
    if ( length(unique(Headers(1,:)))~=1 | length(unique(Headers(2,:)))~=1 )
        error("Les rasters n''ont pas tous la meme dimension");
    end

    ncols = unique(Headers(1,:));    
    nrows = unique(Headers(2,:));
    
    ii = CreateFloatRaster("intersect",Headers(1,1),Headers(2,1),Headers(3,1),Headers(4,1),Headers(5,1),NODATA_value,Headers(7,1));
    
    TestRow = ones(1,ncols)>0;
    ResRow = NODATA_value * ones(1,ncols);
                  
    for r=0:(nrows-1)
        
        TestRow(1:ncols) = %T;
        ResRow(1:ncols) = NODATA_value;
                          
        for h=1:size(TabHandleThreshold,'r')
           rowh = sci_GetRasterRow ( TabHandleThreshold(h,1) , r ) ;
           TestRow = and ( [ rowh > TabHandleThreshold(h,2) ; TestRow ] , 'r' ) ;
        end
               
        ResRow(TestRow) = 1;
        sci_PutRasterRow(ii,r,ResRow);
        
    end
    
endfunction
