// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function LocalP = JackknifeP ( PRECIP , XYZ_precip , ParamPrecip , MeanVariancePrecip )

    [ndays,nprecip] = size(PRECIP);
    LocalP = zeros(PRECIP);

    for p=1:nprecip
        
        // Jackknife gauge p
        
        ixremain = [1:(p-1),(p+1):nprecip];
        
        LocalP(:,p) = BuildLocalRainfall ( PRECIP(:,ixremain) , XYZ_precip(ixremain,:) , XYZ_precip(p,:) , ParamPrecip , MeanVariancePrecip ) ;
        
    end 

endfunction
