// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [ MSE , D_KS ] = CritJackknifeP ( PRECIP , XYZ_precip , SCALEHEIGHT , MeanVariancePrecip )

    nprecip = size(PRECIP,'c');
    MSE = zeros(length(SCALEHEIGHT),nprecip);
    D_KS = zeros(length(SCALEHEIGHT),nprecip);
    
    for p=1:nprecip
        
        // Jackknife gauge p
        
        ixremain = [1:(p-1),(p+1):nprecip];
        
        [ SlopeVario , F0 , MU_Y , VAR_Y , ResidualP_sample ] = DailyP_variography ( PRECIP(:,ixremain) , ..
                                                                                     XYZ_precip(ixremain,:) , ..
                                                                                     MeanVariancePrecip ) ;

        for h = 1:length(SCALEHEIGHT)

            [ VARIO_ResiTemplateP ] = TemplateP_Variography ( PRECIP(:,ixremain) , ..
                                                              XYZ_precip(ixremain,:) , ..
                                                              SCALEHEIGHT(h) ) ;       
                
            LocalP = BuildLocalRainfall2 ( PRECIP(:,ixremain) , XYZ_precip(ixremain,:) , ..
                                                SCALEHEIGHT(h) , MeanVariancePrecip , ..
                                                VARIO_ResiTemplateP , SlopeVario , ..
                                                F0 , MU_Y , VAR_Y , ResidualP_sample , ..
                                                XYZ_precip(p,:) ) ;
        
            ix = LocalP > 0.1 | PRECIP(:,p) > 0.1 ;
            MSE(h,p) = mean ( [ PRECIP(:,p) - LocalP ].^2 ) ;
            D_KS(h,p) = KS_distance ( PRECIP(:,p), LocalP );            
           
            mprintf("Poste %d, H = %d , MSE = %.1f , D_KS = %f\n",p,SCALEHEIGHT(h),MSE(h,p),D_KS(h,p))
        
        end 
    
    end
    
    // Variography for the complete sample

endfunction
