// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function LocalT = JackknifeT ( TEMPER , XYZ_temper , ParamTemper )

    [ndays,ntemper] = size(TEMPER);
    LocalT = zeros(TEMPER);

    for t=1:ntemper
        
        // Jackknife gauge t
        
        ixremain = [1:(t-1),(t+1):ntemper];
        
        LocalT(:,t) = BuildLocalTemperature ( TEMPER(:,ixremain) , XYZ_temper(ixremain,:) , XYZ_temper(t,:) , ParamTemper ) ;
        
    end 

endfunction
