// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [ STREAMS , StreamOrder , downStream , downCell ] = MakeStrahlerStreams ( tree , threshold )

[ TLIST , StreamOrder , downCell ] = sci_MakeStrahlerStreams ( tree , threshold );

// Classement par ordre de Strahler croissant :

[StreamOrder,ix] = gsort(StreamOrder,'g','i');
downCell = downCell(ix);

STREAMS = list();

for i=1:(lstsize(TLIST)-1) 
    STREAMS(i) = getfield ( ix(i)+1 , TLIST ) ;
end

downStream = %nan*downCell ;

for s=1:length(downCell)
    
    // On cherche à quel drain appartient la cellule downCell(s)
    
    OrdreSup = find(StreamOrder>StreamOrder(s));
        
    for k=1:length(OrdreSup)
        
        ix = find ( STREAMS(OrdreSup(k)) == downCell(s) ) ;
        
        if ~isempty(ix) then
           downStream(s)  = OrdreSup(k);
           break;
        end           
        
    end               
    
end

endfunction
