// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function D = NetDistance ( CELLS , fdr , distmap, exu )
    
    FLOWLINES = list();
        
    for i=1:length(CELLS)
        
        FLOWLINES(i) = MakeFlowLine(fdr,CELLS(i),exu);
                
    end
    
    PK = GetRasterValue(distmap,CELLS);
    D = zeros(length(CELLS),length(CELLS));
       
    for i=1:(length(CELLS)-1)
        
        mprintf(" Point %.3d / %.3d...\n",i,length(CELLS))
        
        LCA(i,i)=CELLS(i);
        
        for j=(i+1):length(CELLS)
            
            Fi = flipdim(FLOWLINES(i),1);           
            Fj = flipdim(FLOWLINES(j),1);            
            
            nmax = min(length(Fi),length(Fj));
            Fi = Fi(1:nmax);
            Fj = Fj(1:nmax);
            
            ix = find(Fi~=Fj,1);
            if isempty(ix) then
                D(i,j) = abs(PK(i)-PK(j));
            else
                LCA = Fi(ix-1);
                D(i,j) = PK(i)+PK(j)-2*GetRasterValue(distmap,LCA);
            end
                        
        end
    end   
    
endfunction
