// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [ W_OK , V_OK ] = OrdinaryKriging_fast ( LU_ss , IPIV_ss , Gamm_se , FactVar )
    
    [n_sample,n_estim] = size(Gamm_se);
    
    W_OK = KrigSolveOK ( LU_ss , IPIV_ss , [-Gamm_se ; ones(1,n_estim)] );
    V_OK = zeros(1,n_estim);
    
    for i=1:n_estim    
        V_OK(i) = Gamm_se(:,i)' * W_OK(1:n_sample,i) - W_OK($,i)  ;                 
    end         
    
    V_OK = FactVar * V_OK ;
    
endfunction
