// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [Inum,Iden] = PolylineGradientIntegral ( Polyline , PotentialField )
    
    Header = GetFloatRasterHeader(PotentialField);
    ncols = Header(1);
    
    a = Header(3)
    GridOrigin = [Header(4),Header(5)];
    
    if Header($)==0    // Si (x,y)llcorner
        GridOrigin = GridOrigin + a/2 ;
    end
    
    [ Polyline2 ] = GridIntersect ( Polyline , GridOrigin , a ) ;
    
    MidPoint = 0.5*(Polyline2(1:($-1),:)+Polyline2(2:$,:));
    nseg = size(MidPoint,'r');
    
    OR = GridOrigin.*.ones(nseg,1) ;
    offXY = a * floor ( (1/a)*(MidPoint - OR) ) ;
    XYdeb = Polyline2(1:($-1),:)-OR-offXY ;
    XYfin = Polyline2(2:$,:)-OR-offXY ;
    
    HeaderT = Header ;
    HeaderT(4:5) = HeaderT(4:5)+a/2 ;
    
    C00 = XY2rec(HeaderT,MidPoint);
    Ca0 = C00+1;
    C0a = C00-ncols;
    Caa = C0a+1;
    
    F = GetRasterValue(PotentialField,[C00,Ca0,C0a,Caa]);

    [Inum,Iden] = SegmentGradientIntegral ( XYdeb, XYfin, F, a ) ;

    Inum = sum(Inum);
    Iden = sum(Iden);
    
endfunction
