// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function hresult = RasterCalculator(StrExpr,HandleArgs,NODATA_value)
    
    Headers = zeros(7,length(HandleArgs));
    LocalStrExpr = StrExpr;
    
    for a=1:length(HandleArgs)
        StrArg = sprintf("#%d#",a);
//        StrArg1 = sprintf("%%(%d)",a);
        StrArg1 = sprintf("LocalArgs(%d)",a);
        LocalStrExpr = strsubst(LocalStrExpr,StrArg,StrArg1);
        Headers(:,a) = GetFloatRasterHeader(HandleArgs(a));   
    end
       
    if ( length(unique(Headers(1,:)))~=1 | length(unique(Headers(2,:)))~=1 )
        error("Les rasters n''ont pas tous la meme dimension");
    end
    
    nrows = unique(Headers(2,:));
    
    hresult = CreateFloatRaster("Result",Headers(1,1),Headers(2,1),Headers(3,1),Headers(4,1),Headers(5,1),NODATA_value,Headers(7,1));
       
    for r=0:(nrows-1)
        
        LocalArgs = list();
        
        for a=1:length(HandleArgs)
           ROWa = sci_GetRasterRow(HandleArgs(a),r);
           ROWa(ROWa<=Headers(6,a))=%nan;
           LocalArgs(a) = ROWa;
        end
               
        Result = eval(LocalStrExpr);
        Result(isnan(Result))=NODATA_value;
        sci_PutRasterRow(hresult,r,Result);
        
    end
    
endfunction
