// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [C,A] = SampleAlongPolyline(fdr,acc,XY)
    
    Header = GetFlowDirGridHeader(fdr);
    
    n = size(XY,'r')-1;
    
    // Rasterization "épaisse" de la polyligne
    
    C = [];
    
    for i=1:n
        Ci = RasterizeSegment ( XY( i+[0;1] , :), Header);
        C = [C;Ci(1:($-1))];
    end
    
    C($+1)=Ci($);
    
    TmpRstr = CreateFloatRaster("TmpRstr",Header(1),Header(2),Header(3),Header(4),Header(5),Header(6),Header(7));
    SetRasterToNODATA(TmpRstr);
    
    A = GetRasterValue(acc,C);
    [A,ix]=gsort(A,'g','i');
    C2 = C(ix);
    
    for j=1:length(C2)       
        FlagCatchmentCells ( TmpRstr,fdr,C2(j),j);       
    end
    
    jmax = GetRasterValue(TmpRstr,C2);
    DestroyFloatRaster(TmpRstr);
    
    u = unique(jmax);
    C2 = C2(u);
    A = A(u);
   
   C = C2;
   
   // Eventuellement : reclasser les C2 en fonction de leur ordre d'apparition dans C
    
endfunction
