// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [k1,k2,intrsct,XYinter] = SegmentIntersection ( XYstart1,XYend1, XYstart2,XYend2 )
    
    U1 = XYend1- XYstart1;
    U1 = U1(:,1)+%i*U1(:,2);
    O1 = XYstart1(:,1) + %i* XYstart1(:,2) ;
    
    U2 = XYend2- XYstart2;
    U2 = U2(:,1)+%i*U2(:,2);
    O2 = XYstart2(:,1) + %i* XYstart2(:,2) ;
    
    k1 = zeros(U1);
    k2 = zeros(U2);
    
    provec = real(U2).*imag(U1) - real(U1).*imag(U2 );
    ipara =  abs(provec)==0 ;
    provec(ipara)=%nan ;
    
    k2 = [[imag(O2)-imag(O1)].*real(U1) - [real(O2)-real(O1)].*imag(U1) ]./provec ;
    k1 = -[[imag(O1)-imag(O2)].*real(U2) - [real(O1)-real(O2)].*imag(U2) ]./provec ;
                      
    intrsct = [ k1>0 & k1<1 & k2>0 & k2<1 ];
    
    I = O1 + k1.*U1 ;
    XYinter = [real(I),imag(I)];
    XYinter(~intrsct,:) = %nan ;

endfunction
