// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [ W_SK , V_SK ] = SimpleKriging_fast ( cholK_ss , K_se , Sill )
    
    [n_sample,n_estim] = size(K_se);
    
    W_SK = KrigSolve(cholK_ss,K_se);
    V_SK = zeros(1,n_estim);
    
    for i=1:n_estim 
        V_SK(i) = K_se(:,i)' * W_SK(:,i)  ;                 
    end       
    
    V_SK = Sill * ( 1- V_SK );
    
endfunction
