// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function E = VarioDiff2_wo_nugget ( PARAM , Nugget , typevario , h , g_obs )
         
    typevario = convstr ( part(typevario,1:1) , 'l' );
    Range = max(h) * 0.5 * ( 1 + tanh ( PARAM(1) ) );
    Sill = PARAM(2);    
    
    gr0 = Nugget/Sill ;
      
    select typevario
    case 'e' then    // variogramme exponentiel
        gr = gr0 + (1-gr0) * (1-exp(-h/Range));
    case 's' then    // variogramme sphérique
        gr = ones(h);
        ix = find(h<Range);
        if ~isempty(ix) then
            gr(ix) = gr0 + (1-gr0) * [ 1.5*h(ix)/Range-0.5*(h(ix)/Range).^3 ] ;            
        end
    case 'g' then    // variogramme gaussien
        gr = gr0 + (1-gr0) * (1-exp(-[h/Range].^2));
    end
      
    gr = Sill * gr ;
    E = g_obs - gr ;  
       
endfunction
