// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [h_window,g,Dn] = VarioEmpirique ( XY , Z , nbpoints , moving )
    
    X = XY(:,1);
    Y = XY(:,2);
    n = length(X);
    T = triu(ones(n,n));
    paires = find(T==0);
          
    DX = X'.*.ones(X)-X.*.ones(X');
    DY = Y'.*.ones(Y)-Y.*.ones(Y');
    Dn = sqrt(DX.^2+DY.^2);

    DX = DX(paires);
    DY = DY(paires);
    D = Dn(paires);
    
    DZ = Z'.*.ones(Z)-Z.*.ones(Z');
    E2 = DZ(paires).^2 ;
    [D,ix] = gsort(D,'g','i');
    E2 = E2(ix);
       
    if moving then
        
        nc = length(paires)-nbpoints+1 ;
        h_window = zeros(nc,1);
        h_window(:,1) = D (1:nc) ;
        h_window(:,2) = D([1:nc]+nbpoints-1) ;
                
    else
        
        nc = floor(length(paires)/nbpoints);
        h_window = zeros(nc,1);
        h_window(:,1) = D ( ([1:nc]-1)*nbpoints+1 ) ;
        h_window(:,2) = D([1:nc]*nbpoints) ;     
        h_window(nc,2) = D ( $ );
                
    end
    
    g = zeros(nc,1) ;
       
    for c=1:nc    
        ix = find ( D>=h_window(c,1) & D<=h_window(c,2) ) ;
        g(c) = 0.5*mean(E2(ix)) ;
    end

endfunction
