// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function gr = VarioFit ( D , VARIO )
         
    type_vario = convstr ( part(VARIO(1),1:1) , 'l' );
    Sill = VARIO(2);
    Range = VARIO(3);
    Nugget = VARIO(4);
    
    gr0 = Nugget/Sill ;
      
    select type_vario
    case 'e' then    // variogramme exponentiel
        gr = gr0 + (1-gr0) * (1-exp(-D/Range));
    case 's' then    // variogramme sphérique
        gr = ones(D);
        gr(D<Range) = gr0 + (1-gr0) * [ 1.5*D(D<Range)/Range-0.5*(D(D<Range)/Range).^3 ] ;
    case 'g' then    // variogramme gaussien
        gr = gr0 + (1-gr0) * (1-exp(-[D/Range].^2));
    end
      
    gr = Sill * gr ;
       
endfunction
