// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function K = VarioMatrix ( D , VARIO )
    
    type_vario = convstr ( part(VARIO(1),1:1) , 'l' );
    Sill = VARIO(2);
    Range = VARIO(3);
    Nugget = VARIO(4);
          
    select type_vario
    case 'e' then    // exponential
        G = Nugget + ( Sill - Nugget ) * (1-exp(-D/Range));
    case 's' then    // spherical
        G = Sill * ones(D);
        G(D<Range) = Nugget + ( Sill - Nugget ) * [ 1.5*D(D<Range)/Range-0.5*(D(D<Range)/Range).^3 ] ;
    case 'e' then    // gaussian
        G = Nugget + ( Sill - Nugget ) * (1-exp(-[D/Range].^2));
    end
    
    G = G / Sill ;
    
endfunction
