// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function WriteFlowDirToFile (hr,binfile)

    T = tokens(binfile,'.');
    ext = length(T($))+1;
    hdrfile = part(binfile,1:(length(binfile)-ext))+".hdr";
    
    sci_WriteFlowDirToFile (hr, binfile,6,0);
    
    Header = GetFlowDirGridHeader(hr);
    
     // Ecriture de l'entete
    
    e1 = [ "ncols       " ; ..
           "nrows       "  ..
         ];
    
    if (Header($)==0) then
        xll_label = "xllcorner   ";
        yll_label = "yllcorner   ";
    else
        xll_label = "xllcenter   ";
        yll_label = "yllcenter   ";        
    end
    
    e2 = [ "cellsize    " ;.. 
           xll_label ; ..
           yll_label ; ..
           "NODATA_value" ..
         ];
         
    LIGNES = [ sprintf("%s %d\n",e1,Header(1:2)) ; ..
               sprintf("%s %.3f\n",e2,Header(3:6)) ; ..
               "byteorder    LSBFIRST" ]
	
	fid = mopen(hdrfile,'wt');
	mputl(LIGNES,fid);
	mclose(fid);
	
endfunction
