// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function fdr2df8 ( arcgisfltfile , df8file )
    
    // Convertit un raster de directions d'écoulement généré par ArcGis et exporté en .FLT vers un fichier .DF8
    // Changement des codes de directions + conversion de FLOAT (4 bytes) à UNSIGNED CHAR (1 byte)
    //
    //     32 64 128          0 1 2 
    //     16     1      =>   3   5        
    //      8  4  2           6 7 8
    //                    
          
    fdr_tmp = CreateFlowDirFromBinary ("fdr_tmp",arcgisfltfile,'f','corner',[32,64,128 ; 16,-9999,1 ; 8,4,2] );
    sci_WriteFlowDirToFile (fdr_tmp, df8file,1,0);
    DestroyFlowDirGrid(fdr_tmp);
    
endfunction
