// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function B = isInPolygon(Points,Polygon)

// Teste si des Points [ n , 2 ] est à l'intérieur d'un Polygone [ m , 2 ]

Z0 = Points(:,1)' + %i*Points(:,2)' ;        // Z0 : [1,n]
Z = Polygon(:,1) + %i*Polygon(:,2) ;    // Z : [m,1]
Z = [ Z ; Z(1) ] ;                        // Z : [m+1,1]

Lcar = mean ( abs(diff(Z,1,1)) ); 

Z = Z.*.ones(Z0) - ones(Z).*.Z0 ;        // Z : [m+1,n]

// Si certains points à tester sont quasiment confondus avec l'un des sommets
// du polygone, on renvoie VRAI (évite une division par zéro ensuite...)

isOnVertex = or((abs(Z)/Lcar)<1.0e-6,'r');

B = zeros(isOnVertex)>0;
B(isOnVertex) = %T;

Z2 = Z(:,~isOnVertex);

Angle = imag(diff(log(Z2),1,1));

// Correction des valeurs à l'extérieur de [-pi,pi]

Angle=Angle-2*%pi*(abs(Angle)>%pi).*sign(Angle);

B(~isOnVertex) = abs(sum(Angle,'r'))>=%pi;

endfunction

