// 
// Copyright (C) 2013 UMPC
// 
// This file is part of CLaRiNet.
//  
// CLaRiNet is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// CLaRiNet is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with CLaRiNet.  If not, see <http://www.gnu.org/licenses/>.
function [alpha,theta] = tapered_Pareto ( X , xmin , tol )
    
    n = length(X);
        
    A = mean(log(X/xmin));
    B = mean(X) - xmin;
    
    v = X/xmin; 
    
    //             1   __           1
    // On résout  ---  \   --------------------    =    1 
    //             n   |_  1 - eta (B - A * vi)

    eta = 1/B;
    chg = %T;
    
    while chg
        
        fxn = mean([1-eta*(B-A*v)].^(-1))-1;
        dfxn = mean([B-A*v].*[1-eta*(B-A*v)].^(-2));
        
        eta1 = eta - fxn/dfxn ;        
        chg = abs((eta1-eta)/eta)>tol;
        eta = eta1;
        
    end
    
    theta = 1/eta;
    alpha = (1-eta*B)/A;
    
endfunction
