// ====================================================================
// Allan CORNET
// Simon LIPP
// INRIA 2008
// This file is released into the public domain
// ====================================================================

tmp_dir = pwd();
chdir(get_absolute_file_path('builder_gateway_c.sce')+'..\..');
root_dir = pwd();
chdir(tmp_dir);


if MSDOS then
  // to manage long pathname
  includes_src_c = '-I""' + get_absolute_file_path('builder_gateway_c.sce') + '../../src/cpp""';
else
  includes_src_c = '-I' + get_absolute_file_path('builder_gateway_c.sce') + '../../src/cpp';
end

// PutLhsVar managed by user in sci_sum and in sci_sub
// if you do not this variable, PutLhsVar is added
// in gateway generated (default mode in scilab 4.x and 5.x)

WITHOUT_AUTO_PUTLHSVAR = %F;

tbx_build_gateway('gtw_CLaRiNet', ..
		 [	'sci_CreateFloatRaster'			,	'gtw_CreateFloatRaster'; ..
			'DestroyFloatRaster'			,	'gtw_DestroyFloatRaster'; ..
			'SetRasterToNODATA'			,	'gtw_SetRasterToNODATA';..	
			'SetRasterToConstant'			,	'gtw_SetRasterToConstant';..	
		 	'sci_RasterFromBinary'	,	'gtw_CreateFloatRasterFromBinaryFile'; ..
			'GetFloatRasterHeader'	,	'gtw_GetFloatRasterHeader'; ..
			'GetFloatRasterData'	,	'gtw_GetFloatRasterData' ; ..
			'CreateFlowDirGrid'		,   'gtw_CreateFlowDirGrid' ; ..
			'PutFlowDirValue' 		,   'gtw_PutFlowDirValue' ; ..
			'GetFlowDirValue' 		,   'gtw_GetFlowDirValue' ; ..
			'GetFlowDirGridHeader'	,	'gtw_GetFlowDirGridHeader'; ..
			'DestroyFlowDirGrid'	,	'gtw_DestroyFlowDirGrid' ; ..
			'sci_FlowDirFromBinary'	,	'gtw_CreateFlowDirGridFromBinaryFile'; ..
			'GetCatchmentSize'	,	'gtw_GetCatchmentSize' ; ..
			'GetCatchmentCells'	,	'gtw_GetCatchmentCells' ; ..
			'sci_RasterFindTransition'	,	'gtw_RasterFindTransition' ; ..
			'MainBifurcationNode'	,	'gtw_MainBifurcationNode'; ..
			'GetRasterValue'	,	'gtw_GetRasterValue';..
			'PutRasterValue'	,	'gtw_PutRasterValue';..
			'sci_RasterCDF',	,	'gtw_RasterCDF';..
			'sci_FillDistanceMap'	,	'gtw_MakeDistanceMap';..
			'sci_FillDistanceMap_iter'	,	'gtw_MakeDistanceMap_iter';..
			'sci_MakeAccumulationMap'	,	'gtw_MakeAccumulationMap';..
			'GetDownstreamSet'	,	'gtw_GetDownstreamSet';..
			'sci_WriteRasterToFile'	,	'gtw_WriteRasterToFile';..
			'sci_WriteFlowDirToFile'	,	'gtw_WriteFlowDirToFile';..
//			'CropRasterToCatchment' , 'gtw_CropRasterToCatchment';..
//			'MakeDEMConsistent' , 'gtw_MakeElevConsistentWithFlowDir';..
			'sci_CreateCellTree'			,	'gtw_CreateCellTree'; ..
			'sci_CreateWeightedCellTree'		,	'gtw_CreateWeightedCellTree'
			'sci_CreateCellTree_iter'		,	'gtw_CreateCellTree_iter'
			'DestroyCellTree'			,	'gtw_DestroyCellTree'; ..
			'sci_MakeStreamLines' , 'gtw_MakeStreamLines' ;..		
			'SampleMainStream' , 'gtw_SampleMainStream' ;..
			'SyntheticHypso', 'gtw_SyntheticHypso' ; ..
			'RasterMSE' ,	'gtw_RasterMSE' ; ..
			'sci_GetRasterRow', 'gtw_GetRasterRow' ; ..
			'sci_PutRasterRow' , 'gtw_PutRasterRow' ; ..
			'MakeFlowLine' , 'gtw_MakeFlowLine' ; ..
			'sci_FlagCatchmentCells' , 'gtw_FlagCatchmentCells' ; ..
			'sci_RecursionNoe' , 'gtw_RecursionNoe' ; ..
			'sci_RecursionBohmMohanty' , 'gtw_RecursionBohmMohanty' ; ..
			'RecursionBohmMohanty2' , 'gtw_RecursionBohmMohanty2' ; ..
			'ZeroBJ' , 'gtw_ZeroBJ' ; ..
			'CoverageLevel' , 'gtw_CoverageLevel' ; ..
			'PointWiseConfidence' , 'gtw_PointWiseConfidence' ; ..
			'StrahlerOrdering' , 'gtw_StrahlerOrdering' ; ..
			'UpstreamAverage', 'gtw_UpstreamAverage' ; ..
			'SegmentationTopo', 'gtw_SegmentationTopo' ; ..
			'MakeFlowLineThroughPoint' , 'gtw_MakeFlowLineThroughPoint' ; .. 
			'sci_GetCatchmentSum', 'gtw_GetCatchmentSum' ; ..
			'sci_GetCatchmentSum1', 'gtw_GetCatchmentSum1' ; ..
			'sci_MapCatchmentMean' , 'gtw_MapCatchmentMean' ; ..
			'sci_MapCatchmentSum' , 'gtw_MapCatchmentSum' ; ..
			'sci_MapCatchmentSum1' , 'gtw_MapCatchmentSum1' ; ..
			'sci_OptimMeshVariance' , 'gtw_OptimMeshVariance' ; ..
			'sci_MakeStrahlerStreams' , 'gtw_MakeStrahlerStreams' ; ..
			'sci_RaiseStreamNetwork' , 'gtw_RaiseStreamNetwork' ; ..
			'sci_EuclideanDistanceMap' , 'gtw_EuclideanDistanceMap' ; ..
			'sci_CropRaster' , 'gtw_CropRaster' ; ..
			'sci_CropFlowDir' , 'gtw_CropFlowDir' ; ..
			'SetFlowDirToNoFlow', 'gtw_SetFlowDirToNoFlow' ; ..
			'GaussHermite', 'gtw_GaussHermite' ; ..
			'KrigCholesky', 'gtw_KrigCholesky' ; ..
			'KrigSolve', 'gtw_KrigSolve' ; ..
			'KrigBunchKaufman', 'gtw_KrigBunchKaufman' ; ..
			'KrigSolveOK', 'gtw_KrigSolveOK' ; ..
			'sci_MakeArcs', 'gtw_MakeArcs' ; ..
			'TestCast' , 'gtw_TestCast' ; ..
			'TestEnsembles' , 'gtw_TestEnsembles' ; ..
			'RidgeMagnitudeArea' , 'gtw_RidgeMagnitudeArea' ; ..
			'RidgeMagnitudeDrop' , 'gtw_RidgeMagnitudeDrop' ; ..
			'LinkBodies' , 'gtw_LinkBodies' ; ..
			'sci_BuildPaths' , 'gtw_BuildPaths' ; ..
			'GetDownstreamPath', 'gtw_GetDownstreamPath' ; ..
			], ..
		 ['sci_FloatRaster.c','sci_FlowDirGrid.c','sci_Catchment.c','sci_RasterCalc.c','sci_Correction.c','sci_CellTree.c','sci_Hypsometry.c','sci_FiniteSizeScaling.c','sci_Strahler.c','sci_Mesh.c','sci_Hausdorff.c','sci_Kriging.c','sci_Ridge.c'], ..
                  get_absolute_file_path('builder_gateway_c.sce'), ..
                  [ root_dir+'/src/cpp/libCLaRiNet' , root_dir+'/src/fortran/libLinSolve' ],..
		'',includes_src_c);

clear WITHOUT_AUTO_PUTLHSVAR;

clear tbx_build_gateway;
